#include<mach-o/dyld.h>
#include<stdio.h>

/*Apple wrote their own linker to support extended feature of Mac OS X
  This file was wrote using the instruction in the Porting Command Line Unix Tools to Mac OS X
*/

void * _dlopen(const char * filename, int valor)
{
    NSObjectFileImage fileImage;
    NSObjectFileImageReturnCode returnCode =
    NSCreateObjectFileImageFromFile(filename, &fileImage);
    
    if( returnCode != NSObjectFileImageSuccess)
        return NULL;
    
    NSModule handle = NSLinkModule(fileImage, filename, 
                              NSLINKMODULE_OPTION_BINDNOW |
                              NSLINKMODULE_OPTION_RETURN_ON_ERROR |
                              NSLINKMODULE_OPTION_PRIVATE);    
    return (void *)handle;
}

int _dlclose(void * handle)
{
    return NSUnLinkModule((NSModule)handle, 0);
}

const char * _dlerror()
{
    int null;
    NSLinkEditErrors c;
    const char *errorMsg, *filename;
    NSLinkEditError(&c, &null, &filename, &errorMsg);
    return errorMsg;
}


void * _dlsym(void * handle, void * symbol)
{
    NSSymbol nssym = NSLookupSymbolInModule(handle, symbol);   
    return NSAddressOfSymbol(nssym);     
}